<?php
/* displays a post */

require_once(CLI_DIR.'/cli.conf.php');
/* do not include lib/utility.inc.php */

function cat($id=0, $post=false){
	global $wpdb, $html;
	if(!$post){
		$post=get_post($id);
	}
/* there must be something about user_can_view or something like that */
	if(!$post || ($post->post_status != 'publish')){
		e('<p>No post with that ID.</p>');
	}else{
		$_SESSION['current']=$id;
		$authorinfo=get_userdata($post->post_author);
		if(
			strpos($post->post_content,'<form')!==false
		){
			e('<p>This post is unsuitable for display with the CLI. ');
			if(GUI_URL){
				$u=
				e('<a href="'.get_option('cli_gui_url').'/?'.($status=='static'?'page_id':'p').'='.$id.'">Try the GUI</a>.');
			}
			e('</p>');
		}else{
			e('<div>');
			e('<h1>'.$post->post_title.'</h1>');
			e('<p>'.$post->post_date.' by '.$authorinfo->user_nicename.' in ');
       	/*categories*/
			$cs=get_the_category($id);
			for($ci=0;$ci < count($cs) ;$ci++){
				$cd=$cs[$ci];
				$ca[]="<span onclick=\"showcat('".$cd->cat_ID
					."')\" class=\"linky\">".$cd->cat_name."</span>";
			}
			e(implode(', ',$ca));
			e(' (');
			switch($post->comment_count){
				case 0: e('no comments'); break;
				case 1: e('<span class="linky" onclick="showcomments();">1 comment</span>'); break;
				default: e('<span class="linky" onclick="showcomments();">'.$post->comment_count.' comments</span>');
			}
			e(') <a href="'.get_permalink($id).'">permalink</a> ');
			e(cli_edit_post_link("Edit This",$post));
			e('</p>');	
//			require_once(ABSPATH.'wp-includes/formatting.php');			
			$content=wptexturize(format_to_post($post->post_content));
			/* Greenify any images */
			if(is_writable(CLI_DIR.'/'.IMAGE_CACHE_DIR) && function_exists('imagegif')){
				$content=monochromify_and_rasterize_images_in($content);
			}else{
				err(CLI_DIR.'/'.IMAGE_CACHE_DIR.' not writeable');
			}
			e(nl2br($content));
			e('</div>');			
		}
	}
}

function cli_edit_post_link($link = 'Edit This', $post) {
        if ( is_attachment() )
                return;

        if( $post->post_type == 'page' ) {
                if ( ! current_user_can('edit_page', $post->ID) )
                        return;
                $file = 'page';
        } else {
                if ( ! current_user_can('edit_post', $post->ID) )
                        return;
                $file = 'post';
        }

        $location = get_option('siteurl') . "/wp-admin/{$file}.php?action=edit&amp;post=$post->ID";
        return "<a href=\"$location\">$link</a>";
}

function monochromify_and_rasterize_images_in($content){
	$fg_colour=array(
		'red'		=>get_option('cli_fg_colour_red'),
		'green'	=>get_option('cli_fg_colour_green'),
		'blue'	=>get_option('cli_fg_colour_blue')
	);
	
	$bg_colour=array(
		'red'		=>get_option('cli_bg_colour_red'),
		'green'	=>get_option('cli_bg_colour_green'),
		'blue'	=>get_option('cli_bg_colour_blue')
	);
	$lighter=$fg_colour; 
	$darker=$bg_colour;
	if(grayvalue($lighter) < grayvalue($darker)){
		$lighter=$bg_colour; $darker=$fg_colour;
	}	
	preg_match_all('/(<img[^>]*>)/i',$content,$imgs);
	foreach($imgs[1] as $img){
		preg_match('/src\s*=\s*"([^"]*)"/i',$img,$src);
		preg_match('/alt\s*=\s*"([^"]*)"/i',$img,$alt);
		preg_match('/title\s*=\s*"([^"]*)"/i',$img,$tit);
		$r_cached_image=IMAGE_CACHE_DIR.'/'.md5($src[1]).'.gif';
		$a_cached_image=CLI_DIR.'/'.IMAGE_CACHE_DIR.'/'.md5($src[1]).'.gif';
		if(!file_exists($a_cached_image)){
			$type=strtolower(substr($src[1],strpos($src[1],'.')+1));
			if(!strpos($src[1],'://')){
				// is local
				$imagestring=@file_get_contents(ABSPATH.$src[1]);
				list($width, $height) = @getimagesize(ABSPATH.$src[1]);
			}else{
				$imagestring=@file_get_contents($src[1]);
				list($width, $height) = @getimagesize($src[1]);
			}
			if(!$imagestring) continue;
			$im=imagecreatefromstring($imagestring);
			$nc=get_option('cli_num_colours');
			if (imageistruecolor($im)) {
				imagetruecolortopalette($im, true, $nc);
			}

			/*set up palette*/
			for ($c = 0; $c < imagecolorstotal($im); $c++) {
				$col = imagecolorsforindex($im, $c);
				$gray = grayvalue($col);
				$gray = round($nc * $gray) / $nc;
				foreach(array('red', 'green', 'blue') as $component){
					${$component} = round($gray*($lighter[$component]-$darker[$component]))+$darker[$component];
				}
				imagecolorset($im, $c, $red, $green, $blue);
			}
			$bg=imagecolorallocate($im,$bg_colour['red'],$bg_colour['green'],$bg_colour['blue']);
			$convert=get_option('cli_convert_path');
			if(file_exists(get_option('cli_convert_path'))){
		 		if (!$bg) $bg=imagecolorclosest($im,$bg_colour['red'],$bg_colour['green'],$bg_colour['blue']);
				$basename=CLI_DIR.'/'.IMAGE_CACHE_DIR."/tempgrn".md5($src[1]);
				for($blacken=7;$blacken>=0;$blacken--){
					imagegif($im,$basename.$blacken.'.gif');
					for($r=0;$r<$height;$r+=8){
						imageline ($im, 0, $blacken+$r, 
							$width, $blacken+$r, 
							$bg
						);
					}
				}
				$animate_command = $convert." -delay 100 -loop 1 "
					.$basename."0.gif "
					.$basename."1.gif "
					.$basename."2.gif "
					.$basename."3.gif "
					.$basename."4.gif "
					.$basename."5.gif "
					.$basename."6.gif "
					.$basename."7.gif "
					.$a_cached_image
					;
				exec($animate_command);
				exec("rm ".$basename."*.gif");
			}else{ // no path to convert
				imagegif($im, $a_cached_image);
			}
		}else{
				list($width, $height) = getimagesize($a_cached_image);
		}
		$content = str_replace($img,
			'<img src="'.get_bloginfo('template_directory').'/'
			.$r_cached_image.'" alt="'.$alt[1].'" title="'.$tit[1].'"'
			.' height="'.$height.'" width="'.$width.'"'
			.' />',
			$content);
	}//march 6 voicemail. set up new vm march 7
	return $content;				
}

function grayvalue($colour){
	$gray = (
		  0.299 * $colour['red'] 
		+ 0.587 * $colour['green'] 
		+ 0.114 * $colour['blue']
		)/255; //this line is magic, stolen from php.net
	return $gray;
}
?>
